diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index 0e28885db..5810f7bed 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -70,6 +70,7 @@ import net.minecraft.server.entity.player.ServerPlayer;
 import java.util.ArrayList;
 import java.util.Comparator;
 import java.util.List;
+import java.util.UUID;
 
 public abstract class Player extends Mob
 {
@@ -86,6 +87,7 @@ public abstract class Player extends Mob
     public boolean isSwinging;
     public int swingProgressInt;
     public String username;
+    public UUID uuid;
     public int dimension;
     public double xdO;
     public double ydO;
@@ -476,7 +478,7 @@ public abstract class Player extends Mob
         {
             if (((GoldenArrowProjectile) entityKilledBy).owner instanceof ServerPlayer)
             {
-                if (((ServerPlayer) ((GoldenArrowProjectile) entityKilledBy).owner).username.equals(username))
+                if (((ServerPlayer) ((GoldenArrowProjectile) entityKilledBy).owner).uuid.equals(uuid))
                 {
                     return getDisplayName() + deathMsgColor + " got gold in their eye.";
                 }
@@ -496,7 +498,7 @@ public abstract class Player extends Mob
             }
             else if (((ArrowProjectile) entityKilledBy).owner instanceof ServerPlayer)
             {
-                if (((ServerPlayer) ((ArrowProjectile) entityKilledBy).owner).username.equals(username))
+                if (((ServerPlayer) ((ArrowProjectile) entityKilledBy).owner).uuid.equals(uuid))
                 {
                     return getDisplayName() + deathMsgColor + " lost a game of Russian roulette.";
                 }
@@ -512,7 +514,7 @@ public abstract class Player extends Mob
         {
             if (((CannonballProjectile) entityKilledBy).owner instanceof ServerPlayer)
             {
-                if (((ServerPlayer) ((CannonballProjectile) entityKilledBy).owner).username.equals(username))
+                if (((ServerPlayer) ((CannonballProjectile) entityKilledBy).owner).uuid.equals(uuid))
                 {
                     return getDisplayName() + deathMsgColor + " jumped too high.";
                 }
@@ -761,24 +763,27 @@ public abstract class Player extends Mob
         return TextFormatting.get(chatColor) + name;
     }
 
-    public void displayGUIChest(Container iinventory)
+    public void displayContainerScreen(Container container)
     {
     }
 
-    public void displayGUIWorkbench(int i, int j, int k)
+    public void displayWorkbenchScreen(int x, int y, int z)
     {
     }
 
-    public void displayGUIEditLabel(ItemStack itemstack, int slot)
+    public void displayLabelEditorScreen(ItemStack itemStack, int slot)
     {
     }
 
-    public void displayGUIPaintingPicker()
+    public void displayPaintingPickerScreen()
     {
     }
 
-    public void displayGUIMobSpawnerPicker(int x, int y, int z) { }
-    public void displayGUIWandMonsterPicker(ItemStack stack) { }
+    public void displayMobPickerScreen(int x, int y, int z) { }
+
+    public void displayWandMobPickerScreen(ItemStack itemStack) { }
+
+    public void displayGuidebookScreen() { }
 
     public void onItemPickup(Entity entity, ItemStack item)
     {
@@ -879,7 +884,7 @@ public abstract class Player extends Mob
         if(attacker instanceof WolfMob)
         {
             WolfMob wolf = (WolfMob)attacker;
-            if(wolf.isWolfTamed() && username.equals(wolf.getWolfOwner()))
+            if(wolf.isWolfTamed() && uuid.equals(wolf.getWolfOwner()))
             {
                 return;
             }
@@ -891,7 +896,7 @@ public abstract class Player extends Mob
         List<Entity> list = world.getEntitiesWithinAABB(WolfMob.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
         for (Entity entity : list) {
             WolfMob wolf = (WolfMob) entity;
-            if (wolf.isWolfTamed() && wolf.getTarget() == null && username.equals(wolf.getWolfOwner()) && (!flag || !wolf.isWolfSitting())) {
+            if (wolf.isWolfTamed() && wolf.getTarget() == null && uuid.equals(wolf.getWolfOwner()) && (!flag || !wolf.isWolfSitting())) {
                 wolf.setTarget(attacker);
             }
         }
@@ -917,27 +922,23 @@ public abstract class Player extends Mob
         super.damageEntity(newDamage, damageType);
     }
     
-    public void displayGUIFurnace(FurnaceBlockEntity tileentityfurnace)
-    {
-    }
-
-    public void displayGUITrommel(TrommelBlockEntity tileEntityTrommel)
+    public void displayFurnaceScreen(FurnaceBlockEntity blockEntity)
     {
     }
 
-    public void displayGUIDispenser(DispenserBlockEntity tileentitydispenser)
+    public void displayTrommelScreen(TrommelBlockEntity blockEntity)
     {
     }
 
-    public void displayGUIGuidebook(DispenserBlockEntity tileentitydispenser)
+    public void displayDispenserScreen(DispenserBlockEntity blockEntity)
     {
     }
 
-    public void displayGUIEditSign(SignBlockEntity tileentitysign)
+    public void displaySignEditorScreen(SignBlockEntity blockEntity)
     {
     }
 
-    public void displayGUIEditFlag(FlagBlockEntity tileEntityFlag)
+    public void displayFlagEditorScreen(FlagBlockEntity blockEntity)
     {
     }
 
@@ -1029,7 +1030,7 @@ public abstract class Player extends Mob
     {
     }
 
-    public abstract void func_6420_o();
+    public abstract void animate4();
 
     public void onItemStackChanged(ItemStack itemstack)
     {
diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index 85d4b5a35..bb6b48861 100644
--- a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -701,7 +701,7 @@ public class MinecartEntity extends Entity implements Container {
                 break;
             case CHEST_CART:
                 if(!world.isClientSide) {
-                    player.displayGUIChest(this);
+                    player.displayContainerScreen(this);
                 }
                 break;
             case FURNACE_CART:
diff --git a/src/main/java/net/minecraft/core/item/BucketItem.java b/src/main/java/net/minecraft/core/item/BucketItem.java
index b457c85eb..e4c1579ec 100644
--- a/src/main/java/net/minecraft/core/item/BucketItem.java
+++ b/src/main/java/net/minecraft/core/item/BucketItem.java
@@ -99,7 +99,7 @@ public class BucketItem extends Item
 				player.swingItem();
 				Block block1 = world.getBlock(x, y, z);
 				if(block1 != null) {
-					block1.dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+					block1.dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
 				}
 				world.setBlockAndMetadataWithNotify(x, y, z, idToPlace, 0);
 			}
diff --git a/src/main/java/net/minecraft/core/item/FlagItem.java b/src/main/java/net/minecraft/core/item/FlagItem.java
index b7b6fe05e..4ca93387b 100644
--- a/src/main/java/net/minecraft/core/item/FlagItem.java
+++ b/src/main/java/net/minecraft/core/item/FlagItem.java
@@ -9,6 +9,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.World;
 
 public class FlagItem extends Item
@@ -40,7 +41,7 @@ public class FlagItem extends Item
 					return false;
 				}
 				flag.copyFlagNBT(flagData);
-                flagData.putString("Owner", entityplayer.username); // Sets the owner of the copied flag to the current player so they can actually modify the flag once they place it
+                UUIDHelper.writeToTag(flagData, entityplayer.uuid, "OwnerUUID"); // Sets the owner of the copied flag to the current player so they can actually modify the flag once they place it
 				stack.getData().putCompound("FlagData", flagData);
 				entityplayer.sendStatusMessage(I18n.getInstance().translateKey("flag.copied"));
 				return true;
@@ -82,9 +83,9 @@ public class FlagItem extends Item
                 tileentityflag.readFlagNBT(flagData);
             }
 
-            if (!world.isClientSide && tileentityflag.owner.isEmpty())
+            if (!world.isClientSide && tileentityflag.owner == null)
             {
-                entityplayer.displayGUIEditFlag(tileentityflag);
+                entityplayer.displayFlagEditorScreen(tileentityflag);
             }
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/item/ItemStack.java b/src/main/java/net/minecraft/core/item/ItemStack.java
index 291847976..1497bf1fb 100644
--- a/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -18,7 +18,6 @@ import org.jetbrains.annotations.Nullable;
 
 
 public final class ItemStack {
-    public static ItemStack NO_ITEM = new ItemStack();
 
     public int stackSize;
     public int animationsToGo;
diff --git a/src/main/java/net/minecraft/core/item/Items.java b/src/main/java/net/minecraft/core/item/Items.java
index 4ffc579cc..7a9d62652 100644
--- a/src/main/java/net/minecraft/core/item/Items.java
+++ b/src/main/java/net/minecraft/core/item/Items.java
@@ -259,8 +259,8 @@ public final class Items {
         TOOL_HOE_IRON = (new HoeToolItem("tool.hoe.iron", "minecraft:item/tool_hoe_iron", 16420, ToolMaterial.iron));
         TOOL_HOE_DIAMOND = (new HoeToolItem("tool.hoe.diamond", "minecraft:item/tool_hoe_diamond", 16421, ToolMaterial.diamond));
         TOOL_HOE_GOLD = (new HoeToolItem("tool.hoe.gold", "minecraft:item/tool_hoe_gold", 16422, ToolMaterial.gold));
-        SEEDS_WHEAT = (new SeedsItem("seeds.wheat", "minecraft:item/seeds_wheat", 16423, Blocks.CROPS_WHEAT));
-        WHEAT = (new Item("wheat", "minecraft:item/wheat", 16424));
+        SEEDS_WHEAT = (new SeedsItem("seeds.wheat", "minecraft:item/seeds_wheat", 16423, Blocks.CROPS_WHEAT)).withTags(ItemTags.CHICKENS_FAVOURITE_ITEM);
+        WHEAT = (new Item("wheat", "minecraft:item/wheat", 16424)).withTags(ItemTags.COWS_FAVOURITE_ITEM);
         FOOD_BREAD = (new FoodItem("food.bread", "minecraft:item/food_bread", 16425, 5, 12, false, 8));
 
         ARMOR_HELMET_LEATHER = (new ArmorItem("armor.helmet.leather", "minecraft:item/armor_helmet_leather", 16426, ArmorMaterial.LEATHER, IArmorItem.PIECE_HEAD));
@@ -385,7 +385,7 @@ public final class Items {
         ARMOR_BOOTS_ICESKATES = new IceSkatesItem("armor.boots.iceskates", "minecraft:item/armor_boots_iceskates", 16527);
         TOOL_SHEARS_STEEL = (ToolShearsItem)(new ToolShearsItem("tool.shears.steel", "minecraft:item/tool_shears_steel", 16528, ToolMaterial.steel)).setMaxDamage(ToolMaterial.steel.getDurability());
         TOOL_FIRESTRIKER_STEEL = (new FireStrikerItem("tool.firestriker.steel", "minecraft:item/tool_firestriker_steel", 16529)).setMaxDamage(ToolMaterial.steel.getDurability());
-        SEEDS_PUMPKIN = (new SeedsItem("seeds.pumpkin", "minecraft:item/seeds_pumpkin", 16530, Blocks.CROPS_PUMPKIN));
+        SEEDS_PUMPKIN = (new SeedsItem("seeds.pumpkin", "minecraft:item/seeds_pumpkin", 16530, Blocks.CROPS_PUMPKIN)).withTags(ItemTags.CHICKENS_FAVOURITE_ITEM);
         SEAT = new PlaceableItem("seat", "minecraft:item/seat", 16531, Blocks.SEAT).setMaxStackSize(64);
         DOOR_OAK_PAINTED = (new PaintedDoorItem("door.oak.painted", "minecraft:item/door_oak_painted", 16532, Blocks.DOOR_PLANKS_PAINTED_BOTTOM, Blocks.DOOR_PLANKS_PAINTED_TOP));
         DOOR_GLASS = (new DoorItem("door.glass", "minecraft:item/door_glass", 16533, Blocks.DOOR_GLASS_BOTTOM, Blocks.DOOR_GLASS_TOP));
diff --git a/src/main/java/net/minecraft/core/item/LabelItem.java b/src/main/java/net/minecraft/core/item/LabelItem.java
index dbcdd36e5..366a5ee7b 100644
--- a/src/main/java/net/minecraft/core/item/LabelItem.java
+++ b/src/main/java/net/minecraft/core/item/LabelItem.java
@@ -27,7 +27,7 @@ public class LabelItem extends Item
 		}
 
 		if(slot != -1) {
-			player.displayGUIEditLabel(stack, slot);
+			player.displayLabelEditorScreen(stack, slot);
 		}
 		return stack;
 	}
diff --git a/src/main/java/net/minecraft/core/item/PaintingItem.java b/src/main/java/net/minecraft/core/item/PaintingItem.java
index 3f1f78338..87d05b015 100644
--- a/src/main/java/net/minecraft/core/item/PaintingItem.java
+++ b/src/main/java/net/minecraft/core/item/PaintingItem.java
@@ -25,7 +25,7 @@ public class PaintingItem extends Item
     {
         if (!world.isClientSide && !entityplayer.isSneaking())
         {
-            entityplayer.displayGUIPaintingPicker();
+            entityplayer.displayPaintingPickerScreen();
         }
 
         return itemstack;
diff --git a/src/main/java/net/minecraft/core/item/RopeItem.java b/src/main/java/net/minecraft/core/item/RopeItem.java
index afb078b92..955f815e1 100644
--- a/src/main/java/net/minecraft/core/item/RopeItem.java
+++ b/src/main/java/net/minecraft/core/item/RopeItem.java
@@ -25,7 +25,10 @@ public class RopeItem extends PlaceableItem {
                     blockY = _y;
                     break;
                 } else if (world.getBlock(blockX, _y, blockZ) != blockToPlace) {
-                    break;
+                	if(side == Side.TOP) {
+                		break;
+                	}
+                    return true;
                 }
             }
 
diff --git a/src/main/java/net/minecraft/core/item/SignItem.java b/src/main/java/net/minecraft/core/item/SignItem.java
index 7d80dd70c..da58ccc12 100644
--- a/src/main/java/net/minecraft/core/item/SignItem.java
+++ b/src/main/java/net/minecraft/core/item/SignItem.java
@@ -61,7 +61,7 @@ public class SignItem extends Item
         if(tileentitysign != null)
         {
             tileentitysign.setOwner(entityplayer);
-            entityplayer.displayGUIEditSign(tileentitysign);
+            entityplayer.displaySignEditorScreen(tileentitysign);
         }
         return true;
     }
diff --git a/src/main/java/net/minecraft/core/item/SpawnerWandItem.java b/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
index 019446cbd..5f6bde1f5 100644
--- a/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
+++ b/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
@@ -56,7 +56,7 @@ public class SpawnerWandItem
             }
         }
 
-        player.displayGUIWandMonsterPicker(itemstack);
+        player.displayWandMobPickerScreen(itemstack);
 
         return itemstack;
     }
diff --git a/src/main/java/net/minecraft/core/item/tag/ItemTags.java b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
index 66e2e1847..d97e3c029 100644
--- a/src/main/java/net/minecraft/core/item/tag/ItemTags.java
+++ b/src/main/java/net/minecraft/core/item/tag/ItemTags.java
@@ -1,8 +1,9 @@
 package net.minecraft.core.item.tag;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
+import org.slf4j.Logger;
 
 import java.lang.reflect.Field;
 import java.util.ArrayList;
@@ -10,7 +11,7 @@ import java.util.List;
 
 public abstract class ItemTags
 {
-    
+    private static final Logger LOGGER = LogUtils.getLogger();
     /**
      * Items with this tag will not destroy blocks in creative mode
      */
@@ -27,6 +28,14 @@ public abstract class ItemTags
      * Blocks like doors and levers should not be interacted with when mining them with an item with this tag
      */
     public static Tag<Item> PREVENT_LEFT_CLICK_INTERACTIONS = Tag.of("prevent_left_click_interactions");
+    /**
+     * Chickens will follow the player if they are holding this item.
+     */
+    public static Tag<Item> CHICKENS_FAVOURITE_ITEM = Tag.of("chickens_favourite_item");
+    /**
+     * Cows will follow the player if they are holding this item.
+     */
+    public static Tag<Item> COWS_FAVOURITE_ITEM = Tag.of("cows_favourite_item");
 
     public static List<Tag<Item>> TAG_LIST;
 
@@ -44,7 +53,7 @@ public abstract class ItemTags
                 }
                 catch (Exception e)
                 {
-                    e.printStackTrace();
+                    LOGGER.error("Failed to add tag '{}'!", field.getName(), e);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/core/lang/I18n.java b/src/main/java/net/minecraft/core/lang/I18n.java
index 808480f2e..7cbb05b27 100644
--- a/src/main/java/net/minecraft/core/lang/I18n.java
+++ b/src/main/java/net/minecraft/core/lang/I18n.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.lang;
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.Global;
+import org.slf4j.Logger;
+
 import java.io.IOException;
 import java.io.InputStream;
 import java.net.URI;
@@ -11,6 +15,10 @@ import java.util.List;
 import java.util.stream.Stream;
 
 public class I18n {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static I18n INSTANCE;
+    private Language currentLanguage;
+
     public static void initialize(String languageCode)
     {
         INSTANCE = new I18n(languageCode);
@@ -44,7 +52,7 @@ public class I18n {
             currentLanguage = Language.Default.INSTANCE;
         }
 
-        System.out.println(currentLanguage.keySize() + " Translation Keys");
+        LOGGER.info("{} Translation Keys", currentLanguage.keySize());
     }
 
     public static I18n getInstance()
@@ -66,16 +74,16 @@ public class I18n {
     {
         return translateKey(s + ".name");
     }
-    
+
     public String translateDescKey(String s)
     {
         return translateKey(s + ".desc");
     }
-    
+
     public Language getCurrentLanguage() {
         return currentLanguage;
     }
-	
+
 	public static InputStream getResourceAsStream(String path) {
         return I18n.class.getResourceAsStream(path);
 	}
@@ -123,13 +131,9 @@ public class I18n {
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Exception while loading all files in directory '{}' in translator!", directory, e);
         }
 
         return paths.toArray(new String[0]);
     }
-
-
-    private static I18n INSTANCE;
-    private Language currentLanguage;
 }
diff --git a/src/main/java/net/minecraft/core/lang/Language.java b/src/main/java/net/minecraft/core/lang/Language.java
index f07e367ff..e09fc852b 100644
--- a/src/main/java/net/minecraft/core/lang/Language.java
+++ b/src/main/java/net/minecraft/core/lang/Language.java
@@ -1,5 +1,8 @@
 package net.minecraft.core.lang;
 
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
+
 import java.io.BufferedReader;
 import java.io.IOException;
 import java.io.InputStream;
@@ -21,6 +24,7 @@ import java.util.zip.ZipFile;
  * This method accepts a string as the language ID to be searched with and returns a newly constructed {@link Language} instance.
  */
 public class Language {
+    private static final Logger LOGGER = LogUtils.getLogger();
     /**
      * Used to store any missing translation keys so the log isn't spammed.
      */
@@ -78,7 +82,7 @@ public class Language {
                     {
                         entries.load(reader);
                     } catch (IOException e) {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to load lang file '{}' in '{}'", entry, name, e);
                     }
                 }
                 else if (tips == null && entry.getName().equalsIgnoreCase("tips.txt"))
@@ -87,7 +91,7 @@ public class Language {
                     {
                         tips = Arrays.asList(reader.toString().split("\n"));
                     } catch (IOException e) {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to load 'tips.txt' file in '{}'", name, e);
                     }
                 }
                 else if (entry.getName().equalsIgnoreCase("worldnames.txt"))
@@ -96,7 +100,7 @@ public class Language {
                     {
                         worldNameGenerator = new WorldNameGenerator(bufferedReader.lines().collect(Collectors.toList()));
                     } catch (IOException e) {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to load 'worldnames.txt' file in '{}'", name, e);
                     }
                 }
             }
@@ -113,7 +117,7 @@ public class Language {
         String ret = entries.getProperty(key);
         if (ret == null) {
             if (!reportedMissingTranslations.contains(key)) {
-                System.err.println("Missing translation: " + key + "\n at " + Thread.currentThread().getStackTrace()[2]);
+                LOGGER.error("Missing translation: {}\n at {}", key, Thread.currentThread().getStackTrace()[2]);
                 reportedMissingTranslations.add(key);
             }
             // Try to find in default language then
@@ -182,7 +186,7 @@ public class Language {
                     try (InputStream stream = I18n.getResourceAsStream(path); InputStreamReader reader = new InputStreamReader(stream, StandardCharsets.UTF_8)) {
                         entries.load(reader);
                     } catch (IOException e) {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to load lang file '{}' in '{}'", path, getName(), e);
                     }
                 }
                 else if (tips == null && path.endsWith("/tips.txt"))
@@ -195,7 +199,7 @@ public class Language {
                             tips.add(st);
                         }
                     } catch (IOException e) {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to load 'tips.txt' file in '{}'", getName(), e);
                     }
                 }
                 else if (path.endsWith("/worldnames.txt"))
@@ -204,7 +208,7 @@ public class Language {
                     {
                         worldNameGenerator = new WorldNameGenerator(bufferedReader.lines().collect(Collectors.toList()));
                     } catch (IOException e) {
-                        e.printStackTrace();
+                        LOGGER.error("Failed to load 'worldnames.txt' file in '{}'", getName(), e);
                     }
                 }
             }
@@ -217,7 +221,7 @@ public class Language {
             if (ret == null) {
             	if(!reportedMissingTranslations.contains(key)) {
             		reportedMissingTranslations.add(key);
-            		System.err.println("Missing translation in default language: " + key + "\n at " + Thread.currentThread().getStackTrace()[3]);
+                    LOGGER.error("Missing translation in default language: {}\n at {}", key, Thread.currentThread().getStackTrace()[3]);
             	}
                 return key;
             }
diff --git a/src/main/java/net/minecraft/core/lang/LanguageSeeker.java b/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
index 73cf25313..6f5e53f2f 100644
--- a/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
+++ b/src/main/java/net/minecraft/core/lang/LanguageSeeker.java
@@ -4,9 +4,10 @@ import com.b100.json.JsonParser;
 import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonElement;
 import com.b100.json.element.JsonObject;
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
-import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.io.*;
 import java.nio.charset.StandardCharsets;
@@ -18,11 +19,11 @@ import java.util.zip.ZipFile;
  * Utility class for handling languages.
  */
 public class LanguageSeeker {
+    private static final Logger LOGGER = LogUtils.getLogger();
     /**
      * The directory to load languages from.
      */
     public static final File LANGUAGE_DIR = Global.accessor.getMinecraftDir().toPath().resolve("languages").toFile();
-
     /**
      * Finds a language with a specific ID. If nothing is found, <tt>null</tt> is returned.
      *
@@ -103,7 +104,7 @@ public class LanguageSeeker {
                             }
                             ret.add(new Language(langId, langName, langRegion, langCredits, zip));
                         } catch (IOException e) {
-                            e.printStackTrace();
+                            LOGGER.error("Exception loading json 'lang_info.json'!", e);
                         }
                     }
                 }
diff --git a/src/main/java/net/minecraft/core/net/ICommandListener.java b/src/main/java/net/minecraft/core/net/ICommandListener.java
index 4afafd945..8dd5f436a 100644
--- a/src/main/java/net/minecraft/core/net/ICommandListener.java
+++ b/src/main/java/net/minecraft/core/net/ICommandListener.java
@@ -4,7 +4,7 @@ package net.minecraft.core.net;
 public interface ICommandListener
 {
 
-    void log(String s);
+    void logInfo(String s);
 
     String getUsername();
 }
diff --git a/src/main/java/net/minecraft/core/net/NetworkManager.java b/src/main/java/net/minecraft/core/net/NetworkManager.java
index 7cf24ffd7..684d1fa97 100644
--- a/src/main/java/net/minecraft/core/net/NetworkManager.java
+++ b/src/main/java/net/minecraft/core/net/NetworkManager.java
@@ -1,18 +1,17 @@
 package net.minecraft.core.net;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.Packet;
+import org.slf4j.Logger;
 
 import java.io.*;
 import java.net.*;
 import java.util.*;
 
-// Referenced classes of package net.minecraft.src:
-//            NetworkReaderThread, NetworkWriterThread, Packet, PacketHandler,
-//            NetworkMasterThread, ThreadCloseConnection
-
 public class NetworkManager
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
 	private final boolean silent;
 	public static int PACKET_DELAY = 100;
 
@@ -110,7 +109,7 @@ public class NetworkManager
                         while (sendPacket());
                         try {
                             sleep(PACKET_DELAY);
-                        } catch (InterruptedException e) { }
+                        } catch (InterruptedException ignored) { }
                         try {
                             if (dos != null) {
                                 dos.flush();
@@ -118,8 +117,9 @@ public class NetworkManager
                         } catch (IOException e) {
                             if (!disconnected) {
                                 onNetworkError(e);
+                            } else {
+                                LOGGER.error("IO Exception while flushing Data Output Stream!", e);
                             }
-                            e.printStackTrace();
                         }
                     }
                 }
@@ -232,21 +232,21 @@ public class NetworkManager
 
     private void onNetworkError(Exception exception)
     {
-        if (!silent) exception.printStackTrace();
+        if (!silent) LOGGER.error("Unexpected network error!", exception);
         networkShutdown("disconnect.genericReason", new Object[] {
-            (new StringBuilder()).append("Internal exception: ").append(exception.toString()).toString()
+            "Internal exception: " + exception.toString()
         });
     }
 
-    public void networkShutdown(String s, Object[] aobj)
+    public void networkShutdown(String reason, Object[] reasonObjects)
     {
         if(!running)
         {
             return;
         }
         disconnected = true;
-        disconnectReason = s;
-        disconnectReasonObjects = aobj;
+        disconnectReason = reason;
+        disconnectReasonObjects = reasonObjects;
         new Thread(() -> {
             try
             {
@@ -257,7 +257,7 @@ public class NetworkManager
                     {
                         readThread.stop();
                     }
-                    catch(Throwable throwable) { }
+                    catch(Throwable ignored) { }
                 }
                 if(writeThread.isAlive())
                 {
@@ -265,12 +265,12 @@ public class NetworkManager
                     {
                         writeThread.stop();
                     }
-                    catch(Throwable throwable1) { }
+                    catch(Throwable ignored) { }
                 }
             }
-            catch(InterruptedException interruptedexception)
+            catch(InterruptedException e)
             {
-                interruptedexception.printStackTrace();
+                LOGGER.error("Interrupted while stopping read/write threads!", e);
             }
 
         }).start();
@@ -280,19 +280,19 @@ public class NetworkManager
             dis.close();
             dis = null;
         }
-        catch(Throwable throwable) { }
+        catch(Throwable ignored) { }
         try
         {
             dos.close();
             dos = null;
         }
-        catch(Throwable throwable1) { }
+        catch(Throwable ignored) { }
         try
         {
             socket.close();
             socket = null;
         }
-        catch(Throwable throwable2) { }
+        catch(Throwable ignored) { }
     }
 
     public void processReadPackets()
@@ -346,7 +346,7 @@ public class NetworkManager
             }
             catch(Exception exception)
             {
-                exception.printStackTrace();
+                LOGGER.error("Exception on Server Shutdown!", exception);
             }
         }).start();
     }
diff --git a/src/main/java/net/minecraft/core/net/PlayerProfile.java b/src/main/java/net/minecraft/core/net/PlayerProfile.java
index 102c74bb7..f6eaffd7b 100644
--- a/src/main/java/net/minecraft/core/net/PlayerProfile.java
+++ b/src/main/java/net/minecraft/core/net/PlayerProfile.java
@@ -2,11 +2,14 @@ package net.minecraft.core.net;
 
 import net.minecraft.core.net.command.TextFormatting;
 
+import java.util.UUID;
+
 public class PlayerProfile {
 
-    public PlayerProfile(String name, String nickname, int score, byte chatColour, boolean isOperator)
+    public PlayerProfile(String name, String nickname, UUID uuid, int score, byte chatColour, boolean isOperator)
     {
         playerName = name;
+        this.uuid = uuid;
         this.nickname = nickname;
         scoreTotal = score;
         this.chatColor = chatColour;
@@ -24,6 +27,7 @@ public class PlayerProfile {
     }
 
     public String playerName;
+    public UUID uuid;
     public String nickname;
     public int scoreTotal;
     public byte chatColor;
